<?php
    include_once( 'BingMapPro_Includes.php');

function bmp_maps( $maps, $bmp_api_key, $bmp_menu_links ){
    ?>
        <div class="container-fluid">
            <?php
                bmp_loading_screen();  
                bmp_error_screen(); 
                bmp_donate();
                bmp_delete_modal( 'map' );
                echo $bmp_menu_links;
            ?>
          
      
            
            <div class="panel panel-default bmp-maps-new-panel">
                <div class="panel-heading"> <h3> <?php _e('Maps', 'bing-map-pro');?> </h3></div>
                <div class="panel-body"> 
                    <div class="row"> <span class="newMap"> <img src="<?php echo  plugins_url('/images/icons/expand.png', __FILE__);?>" alt="Add Pin"> </span> </div>              
                 
                <table id="mapsTable"  class='table table-striped'>
                    <thead> <tr> 
                                <th> <?php _e('Active', 'bing-map-pro');?>      </th> 
                                <th> <?php _e('Title', 'bing-map-pro');?>       </th> 
                                <th> <?php _e('Short Code', 'bing-map-pro');?>  </th>
                                <th> <?php _e('Actions', 'bing-map-pro');?>     </th>
                            </tr>
                    </thead>

                    <tbody>
                        <?php
                            foreach( $maps as $map ){ 
                                
                                echo    '<tr id="map_' . esc_html($map['id']) . '">'. 
                                            '<td> '. bmp_showActive( $map['active'], $map['id'] ) . '</td>'.
                                            '<td> '. str_replace('\\', '', esc_html( $map['title'] ) ) . '</td>'.
                                            '<td> <input type="text" readonly value="['. esc_html($map['shortcode']).']"  /> </td>'.
                                            '<td> <button type="button" data-id='.esc_html($map['id']).'  id="edit_bmp_map" class="btn btn-success edit-bmp-map"> <i class="fa fa-edit"></i> </button>'.
                                                ' <button type="button" data-id='.esc_html($map['id']).' onclick="BmpDeleteMap(this)" id="delete_bmp_map" class="btn btn-danger delete-bmp-map"> <i class="fa fa-trash"></i> </button>'.
                                            '</td>'.
                                        '</tr>';
                                
                            }
                            echo '<input type="hidden" name="bmp_map_action" id="bmp_map_action" value="" /> ';
                            echo '<input type="hidden" name="bmp_map_id" id="bmp_map_id" value=""/> '


                        ?>
                    </tbody>
                </table>

                </div>
            </div>


                <form action="" id='bmp_form_action' method="post">
                   <input type="hidden" name="bmp_page_action" id='bmp_page_action' />
                   <input type='hidden' name='bmp_page_map_id' id='bmp_page_map_id' /> 
                </form>
            
            
        
        
        </div>

          <div class="modal fade" id="newMapModal" role="dialog">
                <div class="modal-dialog">
                         
                    <!-- Modal content-->
                    <div class="modal-content">
                    <div class='modal-headline'></div>   
                        <div class="modal-header">
                            
                        <button type="button" class="close" data-dismiss="modal">&times;</button>
                            <h3 class="modal-title"> <?php _e('New Map', 'bing-map-pro');?></h3>
                        </div>
                        <div class="modal-body">                      
                            
                            <div class="input-group">
                                <span class="input-group-addon"> <?php _e('New map: ', 'bing-map-pro');?> </span>
                                <input id="new_map_input" type="text" class="form-control" required='required' name="new_map_input" placeholder=" <?php _e('Map Name ', 'bing-map-pro');?> ">
                            </div>

                        </div>

                        <div class="modal-footer">
                            <button type="button" class="btn btn-default" data-dismiss="modal"> <?php _e('Close', 'bing-map-pro');?></button>
                            <button type="button" id="bmp_add_new_map" class="btn btn-primary" data-dismiss="modal"> <?php _e('Save', 'bing-map-pro');?> </button>
                        </div>
                    </div>
                
                </div>
            </div>

    <?php

}

function bmp_add_map_shapes( $map_id, $bmp_all_shapes, $bmp_map_shapes, $bmp_menu_links ){
    bmp_loading_screen();
    bmp_error_screen();
    bmp_donate();
    echo $bmp_menu_links;
    ?>

    <div class="container-fluid bmp-edit-map-shapes-block">
        <script>
            var $bmp_all_shapes = <?php if( $bmp_all_shapes !== null ){ echo json_encode( $bmp_all_shapes );}else{ echo '[]';}?>;
            var $bmp_map_shapes = <?php if( $bmp_map_shapes !== null ){ echo json_encode( $bmp_map_shapes );}else{ echo '[]';}?>;
            var $bmp_map_id     = "<?php echo $map_id;?>";    
                        
        </script>


        <div class="row">
            <ul class="nav nav-tabs" id='bmp_map_page_nav'>
                <li>  <a href=''> <i class="fas fa-home" style='font-size:28px; color: blue;'></i> </a>  </li>
                <li>  <a id='bmp_edit_map_anchor' href="#"> <?php _e('Map', 'bing-map-pro'); ?></a>       </li>
                <li>  <a id='bmp_map_pins_anchor' href="#">   <?php _e('Map Pins', 'bing-map-pro');?>  </a>  </li>               
                <li class="active"> <a id='bmp_map_shapes_anchor' href="#">   <?php _e('Map Shapes', 'bing-map-pro');?>  </a>  </li>      
            </ul>
        </div>


        <div class='row col-md-6'>
            <div class="panel panel-default pnl-map-added-shapes">
                    <div class="panel-heading">                  
                        <h4> <?php _e('Map Shapes', 'bing-map-pro');?></h4> 
                    </div>
                    <div clss='panel-body'>
                        <table id='tbl_map_added_shapes' class='table table-stripped' data-unique-id='id'>
                        </table> 
                    </div>

            </div>
        </div>
     
        <div class='row col-md-6'>
            <div class="panel panel-default pnl-map-all-shapes">
                    <div class="panel-heading">                  
                        <h4> <?php _e('All Shapes', 'bing-map-pro');?></h4> 
                    </div>
                    <div clss='panel-body'>
                        <table id='tbl_map_all_shapes' class='table table-stripped' data-unique-id='id'>
                        </table>     
                    </div>

            </div>
        </div>


        <form action="" id='bmp_map_form_action' method="post">
            <input type="hidden" value='bmp-add-map-shapes' name="bmp_page_action" id='bmp_page_action' />
            <input type='hidden' value="<?php echo $map_id ?>" name='bmp_page_map_id' id='bmp_page_map_id' />                  
        </form>

    </div>
    <script>
        var bmpIconsUrl   = "<?php echo plugins_url('/images/icons/', __FILE__);?>";
        bmp_RunMapShapesPage();
    </script>

    <?php
}

function bmp_add_map_pins( $map_id, $bmp_api_key, $bmp_all_pins, $bmp_map_pins, $bmp_menu_links ){
    bmp_loading_screen();  
    bmp_error_screen(); 
    bmp_donate();
    echo $bmp_menu_links;
    ?>

    <div class="container-fluid bmp-edit-map-pins-block">

    <script>
        var $bmp_all_pins = <?php if( $bmp_all_pins !== null ){ echo json_encode( $bmp_all_pins );  }else{  echo '[]';}?>;
        var $bmp_map_pins = <?php if( $bmp_map_pins !== 0 ){ echo json_encode( $bmp_map_pins );  }else{  echo '[]';}?>;
        var $bmp_imgs_src = "<?php echo plugins_url('/', __FILE__);?>";
        var $bmp_map_id   = "<?php echo $map_id;?>"; 
        <?php

        ?>
    </script>
    
        <div class="row">
            <ul class="nav nav-tabs" id='bmp_map_page_nav'>
                <li>  <a href=''> <i class="fas fa-home" style='font-size:28px; color: blue;'></i> </a>  </li>
                <li> <a id='bmp_edit_map_anchor' href="#"> <?php _e('Map', 'bing-map-pro'); ?></a>       </li>
                <li class="active"> <a id='bmp_map_pins_anchor' href="#">   <?php _e('Map Pins', 'bing-map-pro');?>  </a>  </li>               
                <li class=""> <a id='bmp_map_shapes_anchor' href="#">   <?php _e('Map Shapes', 'bing-map-pro');?>  </a>  </li>   
            </ul>
        </div>

        <div class='row col-md-6'>
            <div class="panel panel-default pnl-map-added-pins">
                    <div class="panel-heading">                  
                        <h4> <?php _e('Map Pins', 'bing-map-pro');?></h4> 
                    </div>
                    <div clss='panel-body'>
                        <table id='tbl_map_added_pins' class='table table-stripped'>
                            <thead>
                                <tr>   
                                    <th> <?php _e('Action', 'bing-map-pro');?></th>                                   
                                    <th> <?php _e('Active', 'bing-map-pro');?></th>
                                    <th> <?php _e('Name', 'bing-map-pro');?></th>
                                    <th> <?php _e('Address', 'bing-map-pro');?></th>
                                    <th> <?php _e('Lat - Long', 'bing-map-pro');?></th>
                                    <th> <?php _e('Icon', 'bing-map-pro');?></th>                                                                        
                                </tr>
                            </thead>
                            <tbody>

                            </tbody>
                        </table> 
                    </div>

            </div>
        </div>
     
        <div class='row col-md-6'>
            <div class="panel panel-default pnl-map-all-pins">
                    <div class="panel-heading">                  
                        <h4> <?php _e('All Pins', 'bing-map-pro');?></h4> 
                    </div>
                    <div clss='panel-body'>
                    <table id='tbl_map_all_pins' class='table table-stripped'>
                            <thead>
                                <tr>   
                                    <th> <?php _e('Action', 'bing-map-pro');?></th>                                                                       
                                    <th> <?php _e('Name', 'bing-map-pro');?></th>
                                    <th> <?php _e('Address', 'bing-map-pro');?></th>
                                    <th> <?php _e('Lat | Long', 'bing-map-pro');?></th>
                                    <th> <?php _e('Icon', 'bing-map-pro');?></th>                                                                       
                                </tr>
                            </thead>
                            <tbody>

                            </tbody>
                        </table>     
                    </div>

            </div>
        </div>



        <form action="" id='bmp_map_form_action' method="post">
            <input type="hidden" value='edit-map' name="bmp_page_action" id='bmp_page_action' />
            <input type='hidden' value="<?php echo $map_id ?>" name='bmp_page_map_id' id='bmp_page_map_id' />                  
        </form>
    </div>

    <?php
    
}

function bmp_showActive( $isActive, $id ){
    $mapStatus = $isActive ? 'checked' : '';    
    return  "<div class='checkbox'> " .                                    
                "<input type='checkbox' data-id='".$id."' onchange='sendBmpMapResponse(  \"".$id."\", \"active\", \"\" );' ". 
                    $mapStatus .
                 " id='map_status' data-size='mini' data-toggle='toggle' />".            
            "</div>"; 
}

function bmp_editMap( $bmp_map, $bmp_api_key, $map_pins, $bmp_infobox_sizes, $bmp_menu_links, $map_shapes ){ 

        $bmp_measure_types = array('px', '%', 'em', 'vh', 'vw');
        $bmp_map_width_name = 'bmp_map_width_type'; //same for id, drop down measure type
        $bmp_map_height_name = 'bmp_map_height_type'; //same for id, drop down measure type

        $bmp_map_types = array('Street', 'Aerial', 'Birds Eye', 'Canvas Dark', 'Canvas Light', 'Grayscale');
        $bmp_map_type_name = 'bmp_map_type';
        
      
    ?>
    <script>
        var bmpDataMap = JSON.parse( JSON.stringify(<?php echo json_encode( $bmp_map );?>));
        var bmpDataApiKey = '<?php echo $bmp_api_key; ?>';
        var bmpMapAllPins = JSON.parse( JSON.stringify(<?php if( $map_pins == 0) echo '[]'; else echo json_encode(  $map_pins );?>));
        var bmpIconsSrc   = '<?php echo plugins_url('/', __FILE__);?>';
        var bmpPinSizes   = JSON.parse( '<?php echo json_encode( $bmp_infobox_sizes );?>' );
        var bmpFullscreenIconSrc = '<?php echo plugins_url('/images/icons/bmp-map-full-screen.png', __FILE__); ?>';
        var bmpMapShapes  = JSON.parse( JSON.stringify(<?php if ( $map_shapes == 0 ) echo '[]'; else echo json_encode( $map_shapes );?>));        

        bmpMapShapes.forEach( function( item ){
                    try{
                    item.shapeData = item.shapeData.replace(/\\/g, '');
                    item.shapeData = JSON.parse( item.shapeData );
                    item.style = item.style.replace(/\\/g, '' );
                    item.style = JSON.parse( item.style );
                    }catch( e ){
                        console.log( 'Error parsing ' + e.message );
                        console.log( 'Error on ' + item.name );
                    }
        });
       
    </script>
    <?php
        bmp_loading_screen();  
        bmp_error_screen(); 
    //    bmp_error_api_key( $bmp_api_key, 0 );
        bmp_donate();
        echo $bmp_menu_links;
    ?>
    <div class="container-fluid bmp-edit-map-block" style='background: white;'>
    
        <div class="row">
            <ul class="nav nav-tabs" id="bmp_map_page_nav">
                <li><a href=''> <i class="fas fa-home" style='font-size:28px; color: blue;'></i> </a> </li>
                <li class="active"><a href="#"> <?php _e('Map', 'bing-map-pro'); ?></a></li>
                <li><a id='bmp_map_pins_anchor' href="#">   <?php _e('Map Pins', 'bing-map-pro');?> <span class="badge badge-light"><?php echo ($map_pins == null) ? '0' : sizeof( $map_pins); ?></span> </a>  </li>               
                <li class=""> <a id='bmp_map_shapes_anchor' href="#">   <?php _e('Map Shapes', 'bing-map-pro');?>  <span class="badge badge-light"><?php echo ($map_shapes == 0 ) ? '0' : sizeof( $map_shapes ); ?></span> </a>  </li>   
            </ul>
        </div>
        <div class="row">
            <div class="col-md-5" >
                <div class="h4"> <?php _e('Settings', 'bmp-map-pro'); ?></div>
                    <form method='POST' action='' id='form_save_map' >
                        <div class='row bmp-set-row' >
                            <div class="col-sm-4"> </div> 
                            <div class="col-sm-8"> <button class='btn btn-primary bmp-map-save-map' > <?php _e('Save Map', 'bmp-map-pro');?> </button> </div>
                        </div>
                        <hr />
                        <div class='row bmp-set-row' >
                            <div class="col-sm-4 h5"> <?php _e('Active', 'bing-map-pro');?>  </div> 
                            <div class="col-sm-8">  <?php  echo bmp_toggleCkb( esc_html( $bmp_map[0]->map_active ), 'bmp_map_active', 'bmp_map_active'); ?> </div>
                        </div>

                    
                        <div class='row bmp-set-row' >
                            <div class="col-sm-4 h5"> <?php _e('Title:', 'bing-map-pro');?> </div>
                            <div class="col-sm-8"> 
                                <?php $bmp_map_title = str_replace('"', '&#34;', esc_html( $bmp_map[0]->map_title )); $bmp_map_title = str_replace('\\', '', esc_html($bmp_map_title) ); ?>
                                <input  type="text"  name="bmp_map_title" class='form-control' value="<?php echo esc_html($bmp_map_title);?>" 
                                        id="bmp_map_title" placeholder="<?php _e('Map Title', 'bing-map-pro'); ?>" />
                                    
                            </div>
                        </div>
                    

                        <div class='row bmp-set-row' >
                            <div class="col-sm-4 h5"> <?php _e('Width:', 'bing-map-pro');?> </div>                         
                            <div class="col-sm-8"> 
                                <input type="number"  name="bmp_map_width" class='form-control' id="bmp_map_width" value="<?php echo $bmp_map[0]->map_width;?>">                                                
                                <?php bmp_createMeasureType( $bmp_measure_types, $bmp_map[0]->map_width_type, $bmp_map_width_name, $bmp_map_width_name );?>  
                            </div>   
                        </div>
                    

                        <div class='row bmp-set-row' >
                            <div class="col-sm-4 h5"> <?php _e('Height:', 'bing-map-pro');?> </div>
                            <div class="col-sm-8"> 
                                <input type="number" min='10' name="bmp_map_height" class='form-control' id="bmp_map_height" value="<?php echo $bmp_map[0]->map_height;?>"> 
                                <?php bmp_createMeasureType( $bmp_measure_types, $bmp_map[0]->map_height_type, $bmp_map_height_name, $bmp_map_height_name );?>  
                            </div>
                        </div>

                        <div class='row bmp-set-row' >
                            <div class="col-sm-4 h5"> <?php _e('Map Center Lat:', 'bing-map-pro');?> </div>
                            <div class="col-sm-8"> 
                                <input type="text" readonly name="bmp_map_start_lat" class='form-control' id="bmp_map_start_lat" value="<?php echo esc_html( $bmp_map[0]->map_start_lat );?>">                                 
                            </div>
                        </div>

                        <div class='row bmp-set-row' >
                            <div class="col-sm-4 h5"> <?php _e('Map Center Long:', 'bing-map-pro');?> </div>
                            <div class="col-sm-8"> 
                                <input type="text" readonly name="bmp_map_start_long" class='form-control' id="bmp_map_start_long" value="<?php echo esc_html( $bmp_map[0]->map_start_long);?>">                                 
                            </div>
                        </div>

                        <div class='row bmp-set-row' >
                            <div class="col-sm-4 h5"><?php _e('Zoom:', 'bing-map-pro'); ?> </div> 
                            <div class="col-sm-8">
                                <div class="slidecontainer">
                                    <input type="range" min="2" max="20" id="bmp_map_zoom" value="<?php echo esc_html( $bmp_map[0]->map_zoom );?>" class="slider" id="myRange">
                                         <span id='display_zoom_val'> <?php echo esc_html( $bmp_map[0]->map_zoom);?> </span>
                                </div>
                            
                             </div>
                        </div>

                        <div class='row bmp-set-row' >                    
                            <div class="col-sm-4 h5"><strong> <?php _e('Type:', 'bing-map-pro');?> </strong></div> 
                            <div class="col-sm-8"><?php bmp_createMapTypes( $bmp_map_types, $bmp_map[0]->map_type, $bmp_map_type_name, $bmp_map_type_name ) ?> </div>
                        </div>

                        <div class='row bmp-set-row' >
                            <div class="col-sm-4 h5"> <?php _e('Shortcode', 'bing-map-pro');?> </div> 
                            <div class="col-sm-8"> <input type="text" name="bmp_map_shortcode" class='form-control' readonly id="bmp_map_shortcode" value="<?php echo esc_html('[' . $bmp_map[0]->map_shortcode . ']');?>"> </div>
                        </div>

                        <div class='row bmp-set-row' >
                            <div class="col-sm-4 h5"> <?php _e('HTML Class: ', 'bing-map-pro');?> </div> 
                            <div class="col-sm-8"> 
                                <input type="text" name="bmp_map_html_class" class='form-control'  id="bmp_map_html_class"
                                value="<?php echo esc_html( $bmp_map[0]->html_class ); ?>" 
                                placeholder="<?php _e('html class', 'bing-map-pro');?>" /> 
                            </div>
                        </div>

                        <input type='hidden' name='action' value='save_map' />
                    </form>
            </div>
            <div class="col-md-7" style="min-height: 500px; min-width: 300px">
                <div class="h4"> <?php _e('Map', 'bmp-map-pro'); ?>  </div>                
                <div id="bmp_admin_show_map"  style="width: 450px; height: 400px" >                   
                </div>                            
            </div>


            
                <div class="row col-md-12" >
                    <div class="row col-md-12">
                        <h4 style="text-align: center"><?php _e('Advanced Settings', 'bing-map-pro'); ?> </h4>
                    </div>
                    <div class="col-md-4">   

                        <div class='form-inline' style="margin: 7px 0" >
                            <label for="bmp_map_disable_mousewheel"> <?php _e('Disable Mousewheel Zoom:', 'bing-map-pro');?>  </label>
                            <div class="form-group"> 
                                <?php echo bmp_toggleCkb( $bmp_map[0]->disable_mousewheel, 'bmp_map_disable_mousewheel', 'bmp_map_disable_mousewheel' ); ?> 
                            </div>
                        </div>
                    </div>
                    
                    <div class="col-md-4">
                        <div class='form-inline' style="margin: 7px 0" >      
                            <label for="bmp_map_disable_zoom" style="min-width: 110px;"> <?php _e('Disable Zoom:', 'bing-map-pro');?>  </label>
                            <div class="form-group" data-title='<?php _e('Disabling zoom will disable mousewheel zoom too!', 'bing-map-pro') ?>'>                                
                                <?php echo bmp_toggleCkb( $bmp_map[0]->disable_zoom, 'bmp_map_disable_zoom', 'bmp_map_disable_zoom' ); ?>  
                            </div>
                        </div>

                        <div class='form-inline' style="margin: 7px 0" >
                            <label for="bmp_map_compact_nav" style="min-width: 110px;"><?php _e('Compact Nav:', 'bing-map-pro');?> </label> 
                            <div class="form-group">                                 
                                <?php  echo bmp_toggleCkb( $bmp_map[0]->compact_nav, 'bmp_map_compact_nav', 'bmp_map_compact_nav' );?> 
                            </div>
                        </div>      
                    </div>
                    
                    <div class="col-md-4">
                        <div class='form-inline' style="margin: 7px 0" >
                            <label for="bmp_map_show_infobox_hover" style="min-width: 160px;"> <?php _e('Show Infobox On Hover:', 'bing-map-pro');?>  </label>
                            <div class="form-group">                                 
                                <?php  echo bmp_toggleCkb( $bmp_map[0]->styling_enabled, 'bmp_map_show_infobox_hover', 'bmp_map_show_infobox_hover' );?> 
                            </div>
                        </div>    
                    </div>  
                    
                    <div class="col-md-4">
                        <div class='form-inline' style="margin: 7px 0" >
                            <label for="bmp_map_toggle_fullscreen" style="min-width: 160px"> <?php _e('Show Fullscreen icon:', 'bing-map-pro');?>  </label>
                            <div class="form-group">                                
                                <?php  echo bmp_toggleCkb( $bmp_map[0]->toggle_fullscreen, 'bmp_map_toggle_fullscreen', 'bmp_map_toggle_fullscreen' );?> 
                            </div>
                        </div>    
                    </div>  

                </div>   
                    

        <form action="" id='bmp_map_form_action' method="post">
                <input type="hidden" value='bmp-add-map-pins' name="bmp_page_action" id='bmp_page_action' />
                <input type='hidden' value="<?php echo esc_html( $bmp_map[0]->id ); ?>" name='bmp_page_map_id' id='bmp_page_map_id' />                  

        </form>

        </div>


    </div>


<?php   
}

function bmp_createMapTypes( $types, $selType, $name, $id ){
    echo '<table class="table" >';
    echo '<tr>';
    foreach( $types as $key=>$type ){
        $bmp_td = '';
        $bmp_td = '<td>';
        $bmp_td .= "<label for='{$key}_{$id}' class='radio-inline' >";
        if( $key == $selType )
            $bmp_td .= "<input type='radio' class='bmp-map-type' id='{$key}_{$id}' name='{$name}' value='{$key}' checked />";  
        else
            $bmp_td .= "<input type='radio' class='bmp-map-type' id='{$key}_{$id}' name='{$name}' value='{$key}'  />";  
            
            $bmp_td .= "{$type} </label>";
            $bmp_td .= '</td>';
        if( ( $key + 1) % 3 == 0 ){
            $bmp_td .= '</tr>';
            $bmp_td .= '<tr>';
        }
        echo $bmp_td;
    }
    echo '</tr>';
    echo '</table>';
}